<?php
$single = Thegov_Event::getInstance();
$single->set_data();

$title = get_the_title();

$show_likes = Thegov_Theme_Helper::get_option('single_events_likes');
$show_share = Thegov_Theme_Helper::get_option('single_events_share');
$show_views = Thegov_Theme_Helper::get_option('single_events_views');
$single_meta = Thegov_Theme_Helper::get_option('single_events_meta');
$show_tags = Thegov_Theme_Helper::get_option('single_events_meta_tags');

?>

<div class="blog-post blog-post-single-item format-<?php echo esc_attr($single->get_pf()); ?>">
	<div <?php post_class("single_meta"); ?>>
		<div class="item_wrapper">
			<div class="blog-post_content">
				<?php
				
				global $EM_Event;
				/* @var $EM_Event EM_Event */
				if (empty($args['id'])) $args['id'] = rand(); // prevent warnings
				$id = $args['id'];
				?>
				<div class="<?php em_template_classes('view-container'); ?>" id="em-view-<?php echo esc_attr($id); ?>" data-view="event">
					<div class="<?php em_template_classes('event-single'); ?> em-event-<?php echo esc_attr($EM_Event->event_id); ?>" id="em-event-<?php echo esc_attr($id); ?>" data-view-id="<?php echo esc_attr($id); ?>">
						<?php
						echo Thegov_Theme_Helper::render_html($EM_Event->output_single());
						?>
					</div>
				</div>
				<?php
				$advanced_mode_enabled = get_option('dbem_advanced_formatting');
				$event_modes = get_option('dbem_advanced_formatting_modes');
				$elementor_enabled = false === $advanced_mode_enabled || 2 === absint($advanced_mode_enabled) || ($event_modes && 1 === absint($event_modes['event-single']))  ? true : false;
				if($elementor_enabled){
					if ( did_action( 'elementor/loaded' ) ) {	
						if(\Elementor\Plugin::$instance->preview->is_preview_mode( get_the_ID() )){
							the_content();
						}else{
							echo \Elementor\Plugin::$instance->frontend->get_builder_content( get_the_ID() );
						}
					}
				}
				
				if (has_term('', 'event-tags') || (bool)$show_share ||  (bool)$show_views) {
					echo '<div class="post_info single_post_info">';

					if ((bool)$show_views) echo '<div class="blog-post_meta-wrap">';

					if (has_term('', 'event-tags') && !(bool) $show_tags) {
						echo "<div class='tagcloud-wrapper'>";
						the_terms('', 'event-tags', '<div class="tagcloud">', '', '</div>');
						echo "</div>";
					}

					if ((bool)$show_views)  echo '<div class="blog-post_info-wrap">';

					// Views in blog
					if ((bool)$show_views) : ?>
						<div class="blog-post_views-wrap">
							<?php
							$single->get_post_views(get_the_ID());
							?>
						</div>
					<?php
					endif;

					if ((bool)$show_views) : ?>
			</div>
		</div>
	<?php
					endif;

					// Share in blog
					if ((bool)$show_share && function_exists('wgl_theme_helper')) : ?>
		<div class='divider_post_info'></div>
		<div class="blog-post_meta_share">
			<div class="single_info-share_social-wpapper">
				<?php echo wgl_theme_helper()->render_post_share('yes'); ?>
			</div>
		</div>
<?php
					endif;

					echo "</div>";
				} else {
					echo "<div class='divider_post_info'></div>";
				}

?>
	</div>
</div>
</div>
</div>